/*!
 * jquery.transe.js 0.1 - https://github.com/yckart/transe
 * Transformable scroll elements!
 *
 * Inspired by John Polacek's Scrollorama
 *
 * Copyright (c) 2012 Yannick Albert (http://yckart.com)
 * Licensed under the MIT license (http://www.opensource.org/licenses/mit-license.php).
 * 2012/11/21
**/
;(function(e,c,a,g){var d="transe",f={wrapper:e(c),fromElement:false,direction:"vertical",start:0,end:0,property:"",before:0,after:0,easing:"linear",scrollProperty:"scroll",inview:function(i){}},b=function(j,i){this.elem=j;this.$elem=e(j);this.metadata=this.$elem.data(d.toLowerCase()+"-options");this.options=e.extend({},f,i,this.metadata);this.init()},h=b.prototype;h.init=function(){this.slowBrowser="ontouchend" in a||(e.browser.msie&&Number(e.browser.version)<=8)?true:false;this.scrollRange=this.options.end-this.options.start;this.cssArgsBefore={};this.cssArgsAfter={};this.cssArgsBefore[this.options.property]=this.options.before;this.cssArgsAfter[this.options.property]=this.options.after;this.cache=[];if(this.options.fromElement){this._fromElement()}this._startAnimationFrame();return this};h._vendorPrefix=(function(){var k=a.getElementsByTagName("script")[0],l=["Webkit","Moz","O","ms"];for(var j=0;j<l.length;j++){if(l[j]+"Transition" in k.style){return"-"+l[j].toLowerCase()+"-"}}return"transform" in k.style?"":false})();h.scrollProperty={scroll:{getTop:function(i){return i.scrollTop()},setTop:function(i,j){i.scrollTop(j)},getLeft:function(i){return i.scrollLeft()},setLeft:function(i,j){i.scrollLeft(j)}},position:{getTop:function(i){return parseInt(i.css("top"),10)*-1},setTop:function(i,j){i.css("top",j)},getLeft:function(i){return parseInt(i.css("left"),10)*-1},setLeft:function(i,j){i.css("left",j)}},margin:{getTop:function(i){return parseInt(i.css("margin-top"),10)*-1},setTop:function(i,j){i.css("margin-top",j)},getLeft:function(i){return parseInt(i.css("margin-left"),10)*-1},setLeft:function(i,j){i.css("margin-left",j)}},transform:{getTop:function(i){return(i.css(this._vendorPrefix+"transform")!=="none"?parseInt(i.css(this._vendorPrefix+"transform").match(/(-?[0-9]+)/g)[5],10)*-1:0)},setTop:function(i,j){setTransform(i,j,"Y")},getLeft:function(i){return(i.css(this._vendorPrefix+"transform")!=="none"?parseInt(i.css(this._vendorPrefix+"transform").match(/(-?[0-9]+)/g)[4],10)*-1:0)},setLeft:function(i,j){setTransform(i,j,"X")}}};h._fromElement=function(){var j=e(this.options.fromElement),i=j.offset(),l=i.top,n=i.left,k=this.options.wrapper.width(),o=this.options.wrapper.height();this.scrollFromTop=l-o;this.scrollFromLeft=n-k;var m=function(){k=this.options.wrapper.width();o=this.options.wrapper.height();this.scrollFromTop=l-o;this.scrollFromLeft=n-k};c.onresize=m};h._transform=function(){if(this.options.property==="transform"){this.before=this.options.before.split("(");this.after=this.options.after.split("(");this.cssArgsBefore[this.getVendor]=this.options.before;this.cssArgsAfter[this.getVendor]=this.options.after;if(this.options.before.indexOf("deg")!==-1){this.before=this.before[1].split("deg");this.before=parseFloat(this.before[0]);this.after=this.after[1].split("deg");this.after=parseFloat(this.after[0])}else{if(this.options.before.indexOf("scale")!==-1){this.before=this.before[1].split(")");this.before=parseFloat(this.before[0]);this.after=this.after[1].split(")");this.after=parseFloat(this.after[0])}}}else{if(this.options.property==="src"){var m=this.options.before.replace(/^url|[\(\)"']/g,""),i=this.options.after.replace(/^url|[\(\)"']/g,"");this.path=m.substr(0,m.lastIndexOf("/"))||m;this.beforeFile=m.substring(m.lastIndexOf("/")+1,m.lastIndexOf("."));this.afterFile=i.substring(i.lastIndexOf("/")+1,i.lastIndexOf("."));var l=/\.[^.]*$/;this.fileExt=l.exec(m);this.before=parseFloat(this.beforeFile);this.after=parseFloat(this.afterFile);this._preload()}else{if(this.options.property==="color"||this.options.property==="backgroundColor"){var k=/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;this.rgbBefore=k.exec(this.options.before);this.rgbAfter=k.exec(this.options.after)}else{if(this.options.property==="clip"){var j=/^rect|[\(\)"']/g;this.clipBefore=this.options.before.replace(j,"").split(" ");this.clipAfter=this.options.after.replace(j,"").split(" ")}}}}};h._transformIt=function(){var q=this,n,j={};q._transform();if(this.options.direction==="vertical"){n=this.scrollProperty[q.options.scrollProperty].getTop(q.options.wrapper);if(this.options.fromElement){n=n-q.scrollFromTop}}else{if(this.options.direction==="horizontal"){n=this.scrollProperty[q.options.scrollProperty].getLeft(q.options.wrapper);if(this.options.fromElement){n=n-q.scrollFromLeft}}}var l=(n-this.options.start)/this.scrollRange;if(this.options.easing&&e.isFunction(e.easing[this.options.easing])){l=e.easing[this.options.easing](l,l*1000,0,1,1000)}if(n<this.options.end&&n>this.options.start){this.options.inview(this.$elem)}if(n<this.options.start){this.$elem.css(this.cssArgsBefore)}else{if(n>this.options.end){this.$elem.css(this.cssArgsAfter)}else{var r,k;if(this.options.property==="transform"){k=q.before+(q.after-q.before)*l;if(this.options.before.indexOf("rotate")!==-1){if(!this.getVendor&&a.getElementsByTagName("script")[0].style.filter===""){var p=Math.cos(k*(Math.PI*2/360)),m=Math.sin(k*(Math.PI*2/360));r="progid:DXImageTransform.Microsoft.Matrix(M11="+p+", M12="+(-m)+", M21="+m+", M22="+p+", SizingMethod='auto expand')";this.elem.style.marginLeft=-(this.elem.offsetWidth/2)+(this.elem.clientWidth/2)+"px";this.elem.style.marginTop=-(this.elem.offsetHeight/2)+(this.elem.clientHeight/2)+"px"}else{r="rotate("+k+"deg)"}}else{if(this.options.before.indexOf("skew")!==-1){r="skew("+k+"deg)"}else{if(this.options.before.indexOf("scale")!==-1){if(!this.getVendor&&a.getElementsByTagName("script")[0].style.filter===""){r="progid:DXImageTransform.Microsoft.Matrix(M11="+k+", M12=0, M21=0, M22="+k+", SizingMethod='auto expand')"}else{r="scale("+k+")"}}}}j[this.options.property]=r;j[this.getVendor||"filter"]=r;this.$elem.css(j)}else{if(this.options.property==="src"){k=parseInt(q.before+(q.after-q.before)*l,10);r=""+q.path+"/"+k+q.fileExt+"";j[this.options.property]=r;if(q.slowBrowser&&k%2!==0){this.$elem.attr(j)}else{if(!q.slowBrowser){this.$elem.attr(j)}}}else{if(this.options.property==="color"||this.options.property==="backgroundColor"||this.options.property==="borderColor"){var o=function(t,u){var s=q.rgbBefore[t]+(q.rgbAfter[t]-q.rgbBefore[t])*l;return !u?parseInt(s,10):s};if(isNaN(o(4,true))){r="rgb("+o(1)+","+o(2)+","+o(3)+")"}else{r="rgba("+o(1)+","+o(2)+","+o(3)+","+o(4,true)+")"}j[this.options.property]=r;this.$elem.css(j)}else{if(this.options.property==="clip"){var i=function(s){return parseInt(parseFloat(q.clipBefore[s])+(parseFloat(q.clipAfter[s])-parseFloat(q.clipBefore[s]))*l,10)};r="rect("+i(0)+"px,"+i(1)+"px,"+i(2)+"px,"+i(3)+"px)";j[this.options.property]=r;this.$elem.css(j)}else{j[this.options.property]=this.options.before+(this.options.after-this.options.before)*l;this.$elem.css(j)}}}}}}};h._preload=function(){var k=[],m=this.afterFile,n=0;for(var l=1;l<m;l++){k.push(this.path+"/"+l+this.fileExt);var j=a.createElement("img");j.src=k[n++];this.cache.push(j)}};h._startAnimationFrame=function(){var j=this;(function(){var k=0;var m=["ms","moz","webkit","o"];for(var l=0;l<m.length&&!c.requestAnimationFrame;++l){c.requestAnimationFrame=c[m[l]+"RequestAnimationFrame"];c.cancelAnimationFrame=c[m[l]+"CancelAnimationFrame"]||c[m[l]+"CancelRequestAnimationFrame"]}if(!c.requestAnimationFrame){c.requestAnimationFrame=function(n,q){var r=new Date().getTime();var p=Math.max(0,16-(r-k));var o=c.setTimeout(function(){n(r+p)},p);k=r+p;return o}}if(!c.cancelAnimationFrame){c.cancelAnimationFrame=function(n){clearTimeout(n)}}}());(function i(){j.req=requestAnimationFrame(i);j.getScroll();j._transformIt()})()};h.getScroll=function(){return{x:this.scrollProperty[this.options.scrollProperty].getLeft(this.options.wrapper),y:this.scrollProperty[this.options.scrollProperty].getTop(this.options.wrapper)}};h.destroy=function(){this.$elem.each(function(){e(this).removeData("plugin_"+d).removeAttr("style")});cancelAnimationFrame(this.req)};h.option=function(i,j){if(j){this.options[i]=j}else{if(i){return this.options[i]}}};e.fn[d]=function(j){var i=arguments;if(j===g||typeof j==="object"){return this.each(function(){e.data(this,"plugin_"+d,new b(this,j))})}else{if(typeof j==="string"&&j[0]!=="_"&&j!=="init"){var k;this.each(function(){var l=e.data(this,"plugin_"+d);if(l instanceof b&&typeof l[j]==="function"){k=l[j].apply(l,Array.prototype.slice.call(i,1))}});return k!==g?k:this}}};e[d]=function(i){e.extend(f,i)}})(window.jQuery||window.Zepto,window,document);